## radare2-bindings 0.8.8

=== Makefile ===
-include config.mk
PYTHON2_CONFIG=python2.7-config
PYTHON3_CONFIG=python3.2-config

ifneq ($(shell bsdtar -h 2>/dev/null|grep bsdtar),)
TAR=bsdtar czvf
else
TAR=tar -czvf
endif

LANGS=python perl ruby lua go java guile gear gir

W32PY="${HOME}/.wine/drive_c/Python27/"

ifeq ($(DEVEL_MODE),1)
all: supported.langs ruby perl python lua go gear gir
supported.langs:
	CC=${CC} CXX=${CXX} sh check-langs.sh
else
# compile more
all: supported.langs python lua gear gir
supported.langs:
	CC=${CC} CXX=${CXX} sh check-langs.sh force-all
endif

chect:
	rm -f supported.langs
	${MAKE} supported.langs

check-w32:
	if [ ! -d "${W32PY}/libs" ]; then \
		wget http://www.python.org/ftp/python/2.7/python-2.7.msi ; \
		msiexec /i python-2.7.msi ; \
	fi

w32:
	cd python && ${MAKE} w32

DSTNAME=radare2-bindings-w32-$(VERSION)
DST=../$(DSTNAME)/Python27/Lib/r2

w32dist:
	rm -rf ${DST}/*
	mkdir -p ${DST}
	cp -f python/*.dll ${DST}
	cp -f python/r_*.py ${DST}
	cd .. ; zip -r $(DSTNAME).zip $(DSTNAME)

.PHONY: w32dist dist w32 check check-w32 vdoc vdoc_pkg

dist:
	PKG=r2-bindings-${VERSION} ; \
	FILES=`cd .. ; hg st -mac . | grep r2-bindings | grep -v '/\.' | sed -e "s,r2-bindings/,$${PKG}/," | cut -c 3-` ; \
	CXXFILES=`cd .. ; find r2-bindings | grep -e cxx$$ -e py$$ | sed -e "s,r2-bindings/,$${PKG}/,"` ; \
	cd .. && mv r2-bindings $${PKG} && \
	echo $$FILES ; \
	${TAR} $${PKG}.tar.gz $${FILES} $${CXXFILES} ; \
	mv $${PKG} r2-bindings

# TODO: valadoc
vdoc:
	-rm -rf vdoc
	cat vapi/r_*.vapi > libr.vapi
	valadoc --package-version=${VERSION} --package-name=libr --driver 0.13.x -o vdoc libr.vapi
	-rm -f libr.vapi
	# rsync -avz vdoc/* pancake@radare.org:/srv/http/radareorg/vdoc/

vdoc_pkg:
	rm -rf vdoc
	valadoc -o vdoc vapi/*.vapi
	# rsync -avz vdoc/* pancake@radare.org:/srv/http/radareorg/vdoc/

gear:
	cd gear && ${MAKE}

# TODO: unspaguetti this targets
perl:
	@-[ "`grep perl supported.langs`" ] && ( cd perl && ${MAKE} ) || true

python2:
	@-[ "`grep python supported.langs`" ] && ( cd python && ${MAKE} PYTHON_CONFIG=${PYTHON2_CONFIG}) || true

python3:
	@-[ "`grep python supported.langs`" ] && ( cd python && ${MAKE} PYTHON_CONFIG=${PYTHON3_CONFIG}) || true

python:
	@-[ "`grep python supported.langs`" ] && ( cd python && ${MAKE} ) || true

guile:
	@-[ "`grep guile supported.langs`" ] && ( cd guile && ${MAKE} ) || true

ruby:
	@-[ "`grep ruby supported.langs`" ] && ( cd ruby && ${MAKE} ) || true

lua:
	@-[ "`grep lua supported.langs`" ] && ( cd lua && ${MAKE} ) || true

go:
	@-[ -x "${GOBIN}/5g" -o -x "${GOBIN}/6g" -o -x "${GOBIN}/8g" ] && \
	[ "`grep go supported.langs`" ] && ( cd go && ${MAKE} ) || true

java:
	@-[ "`grep java supported.langs`" ] && ( cd java && ${MAKE} ) || true

gir:
	@-[ "`grep gir supported.langs`" ] && ( cd gir && ${MAKE} ) || true

test:
	cd perl && ${MAKE} test
	cd python && ${MAKE} test
	cd ruby && ${MAKE} test
	cd lua && ${MAKE} test
	cd guile && ${MAKE} test
	cd go && ${MAKE} test
	cd java && ${MAKE} test

PYTHON?=python
PYTHON_VERSION?=`${PYTHON} --version 2>&1 | cut -d ' ' -f 2 | cut -d . -f 1,2`
PYTHON_PKGDIR=$(shell ${PYTHON} mp.py)
PYTHON_INSTALL_DIR=${DESTDIR}/${PYTHON_PKGDIR}/r2

.PHONY: purge purge-python

purge: purge-python

purge-python:
	[ -n "${PYTHON_PKGDIR}" ]
	rm -rf ${DESTDIR}/${LIBDIR}/python${PYTHON_VERSION}/*-packages/r2
	rm -rf ${PYTHON_INSTALL_DIR}

install-python:
	@if [ "`grep python supported.langs`" -a -n "${PYTHON_PKGDIR}" ]; then \
	E=${SOEXT} ; [ `uname` = Darwin ] && E=so ; \
	echo "Installing python${PYTHON_VERSION} r2 modules in ${PYTHON_INSTALL_DIR}/r2" ; \
	mkdir -p ${PYTHON_INSTALL_DIR} ; \
	: > ${PYTHON_INSTALL_DIR}/__init__.py ; \
	cp -rf python/r_*.py python/*.$$E ${PYTHON_INSTALL_DIR} ; \
	fi

install-lua:
	@if [ "`grep lua supported.langs`" ]; then \
	for a in 5.1 ; do \
	mkdir -p ${DESTDIR}${PREFIX}/lib/lua/$$a ; \
	echo "Installing lua$$a r2 modules..." ; \
	cp -rf lua/*.${SOEXT} ${DESTDIR}${PREFIX}/lib/lua/$$a ; \
	done ; \
	fi

install-go:
	@if [ "`grep go supported.langs`" ]; then \
	@. ./go/goenv.sh ; \
	if [ -n "$${GOROOT}" -a -n "$${GOOS}" -a -n "$${GOARCH}" ]; then \
	echo "Installing r2 modules in $${GOROOT}/pkg/$${GOOS}_$${GOARCH}" ; \
	cp -f go/*.a go/*.${SOEXT} $${GOROOT}/pkg/$${GOOS}_$${GOARCH} ; \
	else \
	echo "You have to set the following vars: GOROOT, GOOS and GOARCH" ; \
	fi ; \
	fi

install-java:
	@echo "TODO: install-java"

install-ruby:
	@if [ "`grep ruby supported.langs`" ]; then \
	for a in 1.8 1.9.1; do \
	mkdir -p ${DESTDIR}${PREFIX}/lib/ruby/$$a/r2 ; \
	echo "Installing ruby$$a r2 modules..." ; \
	cp -rf ruby/* ${DESTDIR}${PREFIX}/lib/ruby/$$a/r2 ; \
	done ; \
	fi

install-guile:
	@echo TODO: install-guile

install-perl:
	# hack for slpm
	@-if [ "`grep perl supported.langs`" ]; then \
	if [ -n "`echo ${PREFIX}${DESTDIR}|grep home`" ]; then \
		target=${PREFIX}${DESTDIR}`perl -e 'for (@INC) { print "$$_\n" if /lib(64)?\/perl5/ && !/local/; }'|head -n 1` ; \
	else \
		target=${DESTDIR}`perl -e 'for (@INC) { print "$$_\n" if /lib(64)?\/perl5/ && !/local/; }'|head -n 1` ; \
	fi ; \
	mkdir -p $$target/r2 ; \
	echo "Installing perl r2 modules..." ; \
	cp -rf perl/*.so $$target/r2 ; \
	cp -rf perl/*.pm $$target/r2 ; \
	fi

install-vapi:
	@${INSTALL_DIR} ${DESTDIR}${PREFIX}/share/vala/vapi
	${INSTALL_DATA} vapi/*.vapi vapi/*.deps ${DESTDIR}${PREFIX}/share/vala/vapi

EXAMPLEDIR=${DESTDIR}${PREFIX}/share/radare2-swig
install-examples: install-examples-python
	mkdir -p ${EXAMPLEDIR}/vala
	cp -rf vapi/t/*.vala vapi/t/*.gs ${EXAMPLEDIR}/vala

install-examples-python:
	if [ "`grep python supported.langs`" ]; then \
		mkdir -p ${EXAMPLEDIR}/python ; \
		cp -rf python/test-*.py ${EXAMPLEDIR}/python ; \
	fi

install: install-python install-ruby install-perl install-lua install-go install-java install-vapi install-examples

deinstall: uninstall
uninstall:
	cd vapi/ ; for a in *.vapi *.deps ; do rm -f ${DESTDIR}${PREFIX}/share/vala/vapi/$$a ; done
	rm -rf ${EXAMPLEDIR}

oldtest:
	sh do-swig.sh r_bp
	python test.py

clean:
	@for a in $(LANGS); do \
		echo "Cleaning $$a " ; \
		cd $$a ; ${MAKE} clean ; cd .. ; \
	done

mrproper:
	for a in $(LANGS); do \
		cd $$a ; ${MAKE} mrproper; cd .. ; \
	done

version:
	@echo ${VERSION}

.PHONY: $(LANGS) clean mrproper oldtest test all vdoc w32 w32dist check check-w32 deinstall uninstall install version

=== cxx/Makefile ===
LANG=cxx
LANG_EXT=cxx
LIBS_PFX=
PREFIX?=/usr

all: mkcxx

include ../rules.mk

LIBS=r_lib.so
#LIBS=r_search.so r_util.so
LIBS=r_asm.so
#LIBS=r_util.so

mkcxx:
	for a in ${LIBS} ; do \
		mod=`echo $$a|cut -d . -f 1` ; \
		valabind --cxx -m $$mod --vapidir=../vapi $$mod && \
		${CXX} -shared -fPIC -o $$a $${mod}.cxx `pkg-config --cflags --libs $$mod` ; \
	done

mrproper:
	rm -f *.cxx

=== gear/Makefile ===
include ../config.mk
SOEXT=gear
include ../libs.mk

all: ${LIBS}

${LIBS}:
ifeq ($(HAVE_VALABIND),1)
	@PKG=`echo $@|sed -e s,.gear,,` ; \
	VAPI=`echo $@|sed -e s,.gear,.vapi,` ; \
	DEPS="$$(cat ../vapi/$${PKG}.deps 2>/dev/null | awk '{print "--pkg "$$1}')" ; \
	echo "valabind --module $${PKG} $$(echo $$DEPS) --gear ../vapi/$@" ; \
	valabind --module $${PKG} $${DEPS} --gear ../vapi/$${VAPI}
endif

mrproper clean:
	@rm -f *.gear

=== gir/Makefile ===
include ../config.mk
SOEXT=gir
include ../libs.mk

all:
	# XXX sh mkgir.sh RUtil r_util
	sh mkgir.sh RAsm r_asm
	#sh mkgir.sh RCore r_core

all2: ${LIBS}

${LIBS}:
ifeq ($(HAVE_VALABIND)$(HAVE_GIRCOMPILER),11)
	@PKG=`echo $@|sed -e s,.gir,,` ; \
	VAPI=`echo $@|sed -e s,.gir,.vapi,` ; \
	DEPS="$$(cat ../vapi/$${PKG}.deps 2>/dev/null | awk '{print "--pkg "$$1}')" ; \
	echo "valabind --module $${PKG} $$(echo $$DEPS) --gir ../vapi/$@" ; \
	valabind --module $${PKG} $${DEPS} --gir ../vapi/$${VAPI} && \
	g-ir-compiler $${PKG}.gir > $${PKG}.typelib
endif

install:
	rm -f /usr/lib/girepository-1.0/RAsm-1.0.*
	rm -f /usr/lib/girepository-1.0/r_asm-1.0.*
	rm -f /usr/share/gir-1.0/RAsm-1.0.*
	rm -f /usr/share/gir-1.0/r_asm-1.0.*
	cp r_asm.typelib /usr/lib/girepository-1.0/r_asm-1.0.typelib
	cp r_asm.gir /usr/share/gir-1.0/r_asm-1.0.gir
	gjs test.js

mrproper clean:
	@rm -f *.gir *.typelib *.vapi *.vala *.tmp *.c *.h

=== java/Makefile ===
LANG=java
LANG_EXT=java
LIBS_PFX=

include ../rules.mk

=== php5/Makefile ===
LANG=php5
LANG_EXT=php5
LIBS_PFX=

include ../rules.mk

tri:
	valaswig -o r_debug.i -m r_debug --vapidir ../../libr/vapi/ r_debug
	swig -lua -I/usr/include/libr r_debug.i
	gcc r_debug_wrap.c -shared -fPIC -I /usr/include/libr -I /usr/include/lua5.1/ -o _r_debug.so -lr_debug -lr_bp -lr_reg -lr_util

bis:
	valaswig-cc lua r_io -I../../libr/include r_io `pkg-config --libs r_io`

=== debian/changelog ===
radare2-bindings (0.8.8-1) unstable; urgency=low

  * initial release (Closes: #647755)

 -- Sebastian Reichel <sre@debian.org>  Sat, 05 Nov 2011 20:34:45 +0100

=== debian/control ===
Source: radare2-bindings
Section: devel
Priority: extra
Maintainer: Sebastian Reichel <sre@debian.org>
X-Python-Version: >= 2.5
Build-Depends: debhelper (>= 8),
               libradare2-dev (>= 0.8.8),
               gobject-introspection,
               python-dev,
               swig,
               valabind,
               valac-0.14
Standards-Version: 3.9.2
Homepage: http://www.radare.org
Vcs-Browser: http://git.debian.org/?p=collab-maint/radare2-bindings.git
Vcs-Git: git://git.debian.org/collab-maint/radare2-bindings.git

Package: python-radare2
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Description: Python bindings for radare2
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (osx,bsd,linux,w32), stream analyzer, assembler/disassembler (rasm)
 for x86,arm,ppc,m68k,java,msil,sparc code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extracter
 supporting (pe, mach0, elf, class, ...) named rabin, and a block-based
 hash utility called rahash.
 .
 This package contains the Python bindings.

Package: radare2-vala
Architecture: all
Depends: ${misc:Depends}, libradare2-dev
Description: Vala bindings for radare2
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (osx,bsd,linux,w32), stream analyzer, assembler/disassembler (rasm)
 for x86,arm,ppc,m68k,java,msil,sparc code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extracter
 supporting (pe, mach0, elf, class, ...) named rabin, and a block-based
 hash utility called rahash.
 .
 This package contains the Vala bindings.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with python2

override_dh_auto_configure:
	./configure --enable-devel --prefix=/usr

override_dh_auto_test:
	# do not test

override_dh_auto_install:
	mkdir -p $(CURDIR)/debian/tmp
	make install-python install-vapi DESTDIR=$(CURDIR)/debian/tmp

override_dh_python2:
	dh_python2 -ppython-radare2 --no-guessing-versions --no-guessing-deps --namespace=r2

## radare2-bindings 0.9

=== Makefile ===
-include config.mk
PYTHON2_CONFIG=python2.7-config
PYTHON3_CONFIG=python3.2-config

ifneq ($(shell bsdtar -h 2>/dev/null|grep bsdtar),)
TAR=bsdtar czvf
else
TAR=tar -czvf
endif

W32PY="${HOME}/.wine/drive_c/Python27/"
INSTALL_TARGETS=install-vapi

LANGS=
# Experimental:
# LANGS+=gear
# LANGS+=gir
ALANGS=gir gear python ruby perl lua go java guile php5
.PHONY: ${ALANGS}

define ADD_lang
ifneq ($(shell grep $(1) supported.langs),)
LANGS+=$(1)
INSTALL_TARGETS+=install-$(1)
endif
endef

ifneq ($(shell grep python supported.langs),)
INSTALL_EXAMPLE_TARGETS+=install-python-examples
endif

$(foreach p,${ALANGS},$(eval $(call ADD_lang,$(p))))

.PHONY: ${INSTALL_TARGETS} ${INSTALL_EXAMPLE_TARGETS} ${LANG}

ifeq ($(DEVEL_MODE),1)
all: supported.langs ruby perl python lua go gear gir
supported.langs:
	CC=${CC} CXX=${CXX} sh check-langs.sh
else
# compile more
all: supported.langs python lua gear gir
supported.langs:
	CC=${CC} CXX=${CXX} sh check-langs.sh force-all
endif

chect:
	rm -f supported.langs
	${MAKE} supported.langs

check-w32:
	if [ ! -d "${W32PY}/libs" ]; then \
		wget http://www.python.org/ftp/python/2.7/python-2.7.msi ; \
		msiexec /i python-2.7.msi ; \
	fi

w32:
	cd python && ${MAKE} w32

DSTNAME=radare2-bindings-w32-$(VERSION)
DST=../$(DSTNAME)/Python27/Lib/site-packages/r2
SJLJ=/usr/i486-mingw32/bin/libgcc_s_sjlj-1.dll
STDC=/usr/i486-mingw32/bin/libstdc++-6.dll

w32dist:
	rm -rf ../${DSTNAME}
	mkdir -p ${DST}
	cp -f python/*.dll ${DST}
	cp -f python/r_*.py ${DST}
	:> ${DST}/__init__.py
	cd ${DST} ; for a in *.dll ; do mv $$a `echo $$a | sed -e s,dll,pyd,g` ; done
	# Copy missing libraries
	-cp -f ${SJLJ} ${DST}
	-cp -f ${STDC} ${DST}
	cd .. ; zip -r $(DSTNAME).zip $(DSTNAME)

.PHONY: w32dist dist w32 check check-w32 vdoc vdoc_pkg

dist:
	PKG=r2-bindings-${VERSION} ; \
	FILES=`cd .. ; hg st -mac . | grep r2-bindings | grep -v '/\.' | sed -e "s,r2-bindings/,$${PKG}/," | cut -c 3-` ; \
	CXXFILES=`cd .. ; find r2-bindings | grep -e cxx$$ -e py$$ | sed -e "s,r2-bindings/,$${PKG}/,"` ; \
	cd .. && mv r2-bindings $${PKG} && \
	echo $$FILES ; \
	${TAR} $${PKG}.tar.gz $${FILES} $${CXXFILES} ; \
	mv $${PKG} r2-bindings

# TODO: valadoc
vdoc:
	-rm -rf vdoc
	cat vapi/r_*.vapi > libr.vapi
	valadoc --package-version=${VERSION} --package-name=libr --driver 0.13.x -o vdoc libr.vapi
	-rm -f libr.vapi
	# rsync -avz vdoc/* pancake@radare.org:/srv/http/radareorg/vdoc/

vdoc_pkg:
	rm -rf vdoc
	valadoc -o vdoc vapi/*.vapi
	# rsync -avz vdoc/* pancake@radare.org:/srv/http/radareorg/vdoc/

# TODO: unspaguetti this targets
.PHONY: python2 python3
python2:
	@-[ "`grep python supported.langs`" ] && ( cd python && ${MAKE} PYTHON_CONFIG=${PYTHON2_CONFIG}) || true

python3:
	@-[ "`grep python supported.langs`" ] && ( cd python && ${MAKE} PYTHON_CONFIG=${PYTHON3_CONFIG}) || true

${ALANG}::
	cd $@ && ${MAKE}

go::
	[ -x "${GOBIN}/5g" -o -x "${GOBIN}/6g" -o -x "${GOBIN}/8g" ]

test:
	cd perl && ${MAKE} test
	cd python && ${MAKE} test
	cd ruby && ${MAKE} test
	cd lua && ${MAKE} test
	cd guile && ${MAKE} test
	cd go && ${MAKE} test
	cd java && ${MAKE} test

PYTHON?=python
PYTHON_VERSION?=`${PYTHON} --version 2>&1 | cut -d ' ' -f 2 | cut -d . -f 1,2`
PYTHON_PKGDIR=$(shell ${PYTHON} mp.py)
PYTHON_INSTALL_DIR=${DESTDIR}/${PYTHON_PKGDIR}/r2

.PHONY: purge purge-python

purge: purge-python

purge-python:
	[ -n "${PYTHON_PKGDIR}" ] && \
	rm -rf ${DESTDIR}/${LIBDIR}/python${PYTHON_VERSION}/*-packages/r2
	rm -rf ${PYTHON_INSTALL_DIR}

install-python:
	E=${SOEXT} ; [ `uname` = Darwin ] && E=so ; \
	echo "Installing python${PYTHON_VERSION} r2 modules in ${PYTHON_INSTALL_DIR}" ; \
	mkdir -p ${PYTHON_INSTALL_DIR} ; \
	: > ${PYTHON_INSTALL_DIR}/__init__.py ; \
	cp -rf python/r_*.py python/*.$$E ${PYTHON_INSTALL_DIR}

install-lua:
	for a in 5.1 ; do \
		mkdir -p ${DESTDIR}${PREFIX}/lib/lua/$$a ; \
		echo "Installing lua$$a r2 modules..." ; \
		cp -rf lua/*.${SOEXT} ${DESTDIR}${PREFIX}/lib/lua/$$a ; \
	done

install-go:
	@. ./go/goenv.sh ; \
	if [ -n "$${GOROOT}" -a -n "$${GOOS}" -a -n "$${GOARCH}" ]; then \
		echo "Installing r2 modules in $${GOROOT}/pkg/$${GOOS}_$${GOARCH}" ; \
		cp -f go/*.a go/*.${SOEXT} $${GOROOT}/pkg/$${GOOS}_$${GOARCH} ; \
	else \
		echo "You have to set the following vars: GOROOT, GOOS and GOARCH" ; \
	fi

install-java:
	@echo "TODO: install-java"

install-ruby:
	for a in 1.8 1.9.1; do \
		mkdir -p ${DESTDIR}${PREFIX}/lib/ruby/$$a/r2 ; \
		echo "Installing ruby$$a r2 modules..." ; \
		cp -rf ruby/* ${DESTDIR}${PREFIX}/lib/ruby/$$a/r2 ; \
	done

install-perl:
	# hack for slpm
	if [ -n "`echo ${PREFIX}${DESTDIR}|grep home`" ]; then \
		target=${PREFIX}${DESTDIR}`perl -e 'for (@INC) { print "$$_\n" if /lib(64)?\/perl5/ && !/local/; }'|head -n 1` ; \
	else \
		target=${DESTDIR}`perl -e 'for (@INC) { print "$$_\n" if /lib(64)?\/perl5/ && !/local/; }'|head -n 1` ; \
	fi ; \
	mkdir -p $$target/r2 ; \
	echo "Installing perl r2 modules..." ; \
	cp -rf perl/*.so $$target/r2 ; \
	cp -rf perl/*.pm $$target/r2

install-vapi:
	mkdir -p ${DESTDIR}${PREFIX}/share/vala/vapi
	${INSTALL_DATA} vapi/*.vapi vapi/*.deps ${DESTDIR}${PREFIX}/share/vala/vapi

install-gir:
	cd gir && ${MAKE} install

install-php5 install-guile:
	@echo TODO install-$@

EXAMPLEDIR=${DESTDIR}${PREFIX}/share/radare2-swig

install-examples: ${INSTALL_EXAMPLE_TARGETS}
	mkdir -p ${EXAMPLEDIR}/vala
	cp -rf vapi/t/*.vala vapi/t/*.gs ${EXAMPLEDIR}/vala

install-python-examples:
	mkdir -p ${EXAMPLEDIR}/python
	cp -rf python/test-*.py ${EXAMPLEDIR}/python

install: ${INSTALL_TARGETS}

deinstall uninstall:
	cd vapi/ ; for a in *.vapi *.deps ; do rm -f ${DESTDIR}${PREFIX}/share/vala/vapi/$$a ; done
	rm -rf ${EXAMPLEDIR}

oldtest:
	sh do-swig.sh r_bp
	python test.py

clean:
	@for a in $(LANGS); do \
		echo "Cleaning $$a " ; \
		cd $$a ; ${MAKE} clean ; cd .. ; \
	done

mrproper:
	for a in $(LANGS); do cd $$a ; ${MAKE} mrproper; cd .. ; done

version:
	@echo ${VERSION}

.PHONY: $(LANGS) $(ALANGS) 
.PHONY: clean mrproper all vdoc 
.PHONY: oldtest test 
.PHONY: w32 w32dist check check-w32 
.PHONY: deinstall uninstall install version

=== gir/Makefile ===
--- 
+++ 
@@ -2,12 +2,13 @@
 SOEXT=gir
 include ../libs.mk
 
-all:
-	# XXX sh mkgir.sh RUtil r_util
-	sh mkgir.sh RAsm r_asm
+all: ${LIBS}
+
+all2:
+	#sh mkgir.sh RUtil r_util
+	#sh mkgir.sh RAsm r_asm
 	#sh mkgir.sh RCore r_core
 
-all2: ${LIBS}
 
 ${LIBS}:
 ifeq ($(HAVE_VALABIND)$(HAVE_GIRCOMPILER),11)

=== lua/Makefile ===
LANG=lua
LANG_EXT=lua
LIBS_PFX=

include ../rules.mk

tri:
	valaswig -o r_debug.i -m r_debug --vapidir ../../libr/vapi/ r_debug
	swig -lua -I/usr/include/libr r_debug.i
	gcc r_debug_wrap.c -shared -fPIC -I /usr/include/libr -I /usr/include/lua5.1/ -o _r_debug.so -lr_debug -lr_bp -lr_reg -lr_util

bis:
	valaswig-cc lua r_io -I../../libr/include r_io `pkg-config --libs r_io`

=== python/Makefile ===
LANG=python
LANG_EXT=py
LIBS_PFX=_
PREFIX?=/usr

include ../rules.mk

tri:
	valaswig -o r_debug.i -m r_debug --vapidir ../../libr/vapi/ r_debug
	swig -python -I/usr/include/libr r_debug.i
	$(CC) r_debug_wrap.c -shared -fPIC -I /usr/include/libr -I /usr/include/python2.6/ -o _r_debug.so -lr_debug -lr_bp -lr_reg -lr_util

mytest:
	mkdir -p r2
	cp r_bin.py* r2
	cp _r_bin* r2
	PYTHONPATH=. python test-r_bin.py

bis:
	valaswig-cc python r_io -I../../libr/include r_io `pkg-config --libs r_io`

mrproper:
	a=python`python --version 2>&1 | cut -d ' ' -f 2 | cut -d . -f 1,2`/site-packages ; \
	rm -rf ${PREFIX}/lib/$a/r2

=== debian/changelog ===
radare2-bindings (0.9-1) unstable; urgency=low

  * New upstream release

 -- Sebastian Reichel <sre@debian.org>  Tue, 06 Dec 2011 02:13:31 +0100

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,11 @@
 Maintainer: Sebastian Reichel <sre@debian.org>
 X-Python-Version: >= 2.5
 Build-Depends: debhelper (>= 8),
-               libradare2-dev (>= 0.8.8),
+               libradare2-dev (>= 0.9),
                gobject-introspection,
                python-dev,
                swig,
-               valabind,
+               valabind (>= 0.6.4),
                valac-0.14
 Standards-Version: 3.9.2
 Homepage: http://www.radare.org
@@ -28,7 +28,7 @@
  (osx,bsd,linux,w32), stream analyzer, assembler/disassembler (rasm)
  for x86,arm,ppc,m68k,java,msil,sparc code analysis modules and
  scripting facilities. A bindiffer named radiff, base converter (rax),
- shellcode development helper (rasc), a binary information extracter
+ shellcode development helper (rasc), a binary information extractor
  supporting (pe, mach0, elf, class, ...) named rabin, and a block-based
  hash utility called rahash.
  .
@@ -36,7 +36,7 @@
 
 Package: radare2-vala
 Architecture: all
-Depends: ${misc:Depends}, libradare2-dev
+Depends: ${misc:Depends}, libradare2-dev (>= 0.9)
 Description: Vala bindings for radare2
  The project aims to create a complete, portable, multi-architecture,
  unix-like toolchain for reverse engineering.
@@ -46,7 +46,7 @@
  (osx,bsd,linux,w32), stream analyzer, assembler/disassembler (rasm)
  for x86,arm,ppc,m68k,java,msil,sparc code analysis modules and
  scripting facilities. A bindiffer named radiff, base converter (rax),
- shellcode development helper (rasc), a binary information extracter
+ shellcode development helper (rasc), a binary information extractor
  supporting (pe, mach0, elf, class, ...) named rabin, and a block-based
  hash utility called rahash.
  .

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,9 @@
 override_dh_auto_test:
 	# do not test
 
+override_dh_auto_build:
+	make python2
+
 override_dh_auto_install:
 	mkdir -p $(CURDIR)/debian/tmp
 	make install-python install-vapi DESTDIR=$(CURDIR)/debian/tmp

=== debian/watch ===
version=3
http://radare.org/get/r2-bindings-([\d\.]+)\.tar\.gz

## radare2-bindings 0.9.6

=== Makefile ===
--- 
+++ 
@@ -1,31 +1,38 @@
--include config.mk
+# Requires ./configure
+include config.mk
+
+PREFIX?=/usr
 PYTHON2_CONFIG=python2.7-config
 PYTHON3_CONFIG=python3.2-config
 
 ifneq ($(shell bsdtar -h 2>/dev/null|grep bsdtar),)
-TAR=bsdtar czvf
-else
-TAR=tar -czvf
+TAR=bsdtar cJvf
+else
+TAR=tar -cJvf
 endif
 
 W32PY="${HOME}/.wine/drive_c/Python27/"
+
+ifneq ($(shell grep valac supported.langs 2>/dev/null),)
 INSTALL_TARGETS=install-vapi
+else
+INSTALL_TARGETS=
+endif
 
 LANGS=
 # Experimental:
-# LANGS+=gear
 # LANGS+=gir
-ALANGS=gir gear python ruby perl lua go java guile php5
+ALANGS=awk gir python ruby perl lua go java guile php5
 .PHONY: ${ALANGS}
 
 define ADD_lang
-ifneq ($(shell grep $(1) supported.langs),)
+ifneq ($(shell grep $(1) supported.langs 2>/dev/null),)
 LANGS+=$(1)
 INSTALL_TARGETS+=install-$(1)
 endif
 endef
 
-ifneq ($(shell grep python supported.langs),)
+ifneq ($(shell grep python supported.langs 2>/dev/null),)
 INSTALL_EXAMPLE_TARGETS+=install-python-examples
 endif
 
@@ -34,12 +41,17 @@
 .PHONY: ${INSTALL_TARGETS} ${INSTALL_EXAMPLE_TARGETS} ${LANG}
 
 ifeq ($(DEVEL_MODE),1)
-all: supported.langs ruby perl python lua go gear gir
+LANGS=$(shell cat supported.langs 2>/dev/null)
+all: supported.langs
+	@for a in ${LANGS} ; do \
+		[ $$a = valac ] && continue; \
+		(cd $$a && ${MAKE} ) ; done
+
 supported.langs:
 	CC=${CC} CXX=${CXX} sh check-langs.sh
 else
 # compile more
-all: supported.langs python lua gear gir
+all: supported.langs python lua gir
 supported.langs:
 	CC=${CC} CXX=${CXX} sh check-langs.sh force-all
 endif
@@ -78,18 +90,21 @@
 
 dist:
 	PKG=r2-bindings-${VERSION} ; \
-	FILES=`cd .. ; hg st -mac . | grep r2-bindings | grep -v '/\.' | sed -e "s,r2-bindings/,$${PKG}/," | cut -c 3-` ; \
+	DIR=`basename $$PWD` ; \
+	FILES=`git ls-files | sed -e s,^,r2-bindings-${VERSION}/,` ; \
 	CXXFILES=`cd .. ; find r2-bindings | grep -e cxx$$ -e py$$ | sed -e "s,r2-bindings/,$${PKG}/,"` ; \
-	cd .. && mv r2-bindings $${PKG} && \
+	cd .. && mv $${DIR} $${PKG} && \
 	echo $$FILES ; \
-	${TAR} $${PKG}.tar.gz $${FILES} $${CXXFILES} ; \
-	mv $${PKG} r2-bindings
+	${TAR} $${PKG}.tar.xz $${FILES} $${CXXFILES} ; \
+	mv $${PKG} $${DIR}
 
 # TODO: valadoc
 vdoc:
 	-rm -rf vdoc
 	cat vapi/r_*.vapi > libr.vapi
-	valadoc --package-version=${VERSION} --package-name=libr --driver 0.13.x -o vdoc libr.vapi
+	valadoc --package-version=${VERSION} --package-name=libr -o vdoc libr.vapi
+	sed -e 's,font-family:.*,font-family:monospace;,' vdoc/style.css > vdoc/.style.css
+	mv vdoc/.style.css vdoc/style.css
 	-rm -f libr.vapi
 	# rsync -avz vdoc/* pancake@radare.org:/srv/http/radareorg/vdoc/
 
@@ -110,7 +125,7 @@
 	cd $@ && ${MAKE}
 
 go::
-	[ -x "${GOBIN}/5g" -o -x "${GOBIN}/6g" -o -x "${GOBIN}/8g" ]
+	@-[ -x "${GOBIN}/5g" -o -x "${GOBIN}/6g" -o -x "${GOBIN}/8g" ]
 
 test:
 	cd perl && ${MAKE} test
@@ -121,14 +136,20 @@
 	cd go && ${MAKE} test
 	cd java && ${MAKE} test
 
-PYTHON?=python
+PYTHON?=`pwd`/python-wrapper
 PYTHON_VERSION?=`${PYTHON} --version 2>&1 | cut -d ' ' -f 2 | cut -d . -f 1,2`
 PYTHON_PKGDIR=$(shell ${PYTHON} mp.py)
 PYTHON_INSTALL_DIR=${DESTDIR}/${PYTHON_PKGDIR}/r2
 
-.PHONY: purge purge-python
-
-purge: purge-python
+.PHONY: purge purge-python install-cxx
+
+purge: purge-python purge-java
+
+install-cxx:
+	@echo TODO: install-cxx
+
+purge-java:
+	cd java && ${MAKE} purge
 
 purge-python:
 	[ -n "${PYTHON_PKGDIR}" ] && \
@@ -136,18 +157,25 @@
 	rm -rf ${PYTHON_INSTALL_DIR}
 
 install-python:
+	[ -e python/_r_core.${SOEXT} ] && true
 	E=${SOEXT} ; [ `uname` = Darwin ] && E=so ; \
 	echo "Installing python${PYTHON_VERSION} r2 modules in ${PYTHON_INSTALL_DIR}" ; \
 	mkdir -p ${PYTHON_INSTALL_DIR} ; \
 	: > ${PYTHON_INSTALL_DIR}/__init__.py ; \
 	cp -rf python/r_*.py python/*.$$E ${PYTHON_INSTALL_DIR}
 
-install-lua:
-	for a in 5.1 ; do \
-		mkdir -p ${DESTDIR}${PREFIX}/lib/lua/$$a ; \
-		echo "Installing lua$$a r2 modules..." ; \
-		cp -rf lua/*.${SOEXT} ${DESTDIR}${PREFIX}/lib/lua/$$a ; \
-	done
+LUAPATH=$(shell strings `../sys/whereis.sh lua`| grep lib/lua | cut -d ';' -f 2 | grep '.so'  | cut -d '?' -f 1)
+
+LUAPKG=$(shell pkg-config --list-all|awk '/lua|lua-/{print $$1;}')
+ifneq (${LUAPKG},)
+LUADIR=$(shell pkg-config --variable=INSTALL_CMOD ${LUAPKG})
+lua-install install-lua:
+	@mkdir -p ${DESTDIR}${LUADIR} ; \
+	echo "Installing lua r2 modules... ${DESTDIR}${LUADIR}" ; \
+	cp -rf lua/*.so ${DESTDIR}${LUADIR}/
+else
+lua-install install-lua:
+endif
 
 install-go:
 	@. ./go/goenv.sh ; \
@@ -159,7 +187,7 @@
 	fi
 
 install-java:
-	@echo "TODO: install-java"
+	cd java && ${MAKE} install
 
 install-ruby:
 	for a in 1.8 1.9.1; do \
@@ -184,6 +212,12 @@
 	mkdir -p ${DESTDIR}${PREFIX}/share/vala/vapi
 	${INSTALL_DATA} vapi/*.vapi vapi/*.deps ${DESTDIR}${PREFIX}/share/vala/vapi
 
+AWKDIR=${DESTDIR}${PREFIX}/lib/radare2/${VERSION}/awk
+install-awk:
+	mkdir -p ${AWKDIR}
+	sed -e 's,@AWKDIR@,${AWKDIR},g' < awk/r2awk > ${DESTDIR}${PREFIX}/bin/r2awk
+	cp -f awk/* ${AWKDIR}/
+
 install-gir:
 	cd gir && ${MAKE} install
 
@@ -212,8 +246,10 @@
 
 clean:
 	@for a in $(LANGS); do \
+		if [ -d $$a ]; then \
 		echo "Cleaning $$a " ; \
-		cd $$a ; ${MAKE} clean ; cd .. ; \
+		( cd $$a && ${MAKE} clean ) ; \
+		fi ; \
 	done
 
 mrproper:
@@ -222,8 +258,8 @@
 version:
 	@echo ${VERSION}
 
-.PHONY: $(LANGS) $(ALANGS) 
-.PHONY: clean mrproper all vdoc 
-.PHONY: oldtest test 
-.PHONY: w32 w32dist check check-w32 
+.PHONY: $(LANGS) $(ALANGS)
+.PHONY: clean mrproper all vdoc
+.PHONY: oldtest test
+.PHONY: w32 w32dist check check-w32
 .PHONY: deinstall uninstall install version

=== ctypes/Makefile ===
LANG=ctypes
LANG_EXT=py
LIBS_PFX=
FORCE_SOEXT=1
MY_SOEXT=py

include ../rules.mk

=== go/Makefile ===
LANG=go
LANG_EXT=go
LIBS_PFX=

include ../rules.mk

%.so:
	@-test ../../libr/vapi/`echo $@|sed -e s,.so,.vapi,` -nt ${LIBS_PFX}$@ ; \
	if [ ! $$? = 0 ]; then \
	  if [ ! -e ${LIBS_PFX}$@ ]; then \
            true ; \
          else \
            false ; \
          fi ; \
	fi ; \
	. ./goenv.sh ; \
	if [ $$? = 0 ]; then \
	  (cd .. && sh do-swig.sh ${LANG} `echo $@ | sed -e s,.so,,`) ; \
	  ./fixgoswig.sh `echo $@ | sed -e s,.so,.go,` ; \
	  echo $${GOC} `echo $@ | sed -e s,.so,.go,` ; \
	  $${GOC} `echo $@ | sed -e s,.so,.go,` ; \
	  echo $${GOCC} $${GO_FLAGS} -I ${GOROOT}/pkg/$${GOOS}_$${GOARCH} `echo $@ | sed -e s,.so,_gc.c,` ; \
	  $${GOCC} $${GO_FLAGS} -I ${GOROOT}/pkg/$${GOOS}_$${GOARCH} `echo $@ | sed -e s,.so,_gc.c,` ; \
	  gopack grc `echo $@ | sed -e s,.so,.a,` `echo $@ | sed -e s,.so,.$${GO_N},` `echo $@ | sed -e s,.so,_gc.$${GO_N},` ; \
	fi

rbintest:
	. ./goenv.sh ; \
	$${GOC} -I. test-r_bin.go ; \
	$${GOL} -L. test-r_bin.$${GO_N} ; \
	LD_LIBRARY_PATH=. ./$${GO_N}.out /bin/ls

ibintest:
	. ./goenv.sh ; \
	$${GOC} test-r_bin.go ; \
	$${GOL} test-r_bin.$${GO_N} ; \
	./$${GO_N}.out /bin/ls

=== guile/Makefile ===
LANG=guile
LANG_EXT=scm
LIBS_PFX=

include ../rules.mk

patch:
	cd ../ ; patch -p2 < guile/vapi.patch

unpatch:
	cd ../ ; patch -R -p2 < guile/vapi.patch

run:
	GUILE_WARN_DEPRECATED=no guile test-asm.scm
	GUILE_WARN_DEPRECATED=no guile test-util.scm

=== python/Makefile ===
LANG=python
LANG_EXT=py
LIBS_PFX=_
PREFIX?=/usr

include ../rules.mk

tri:
	valabind --swig -N Radare -o r_debug.i -m r_debug --vapidir ../../libr/vapi/ r_debug
	swig -python -I/usr/include/libr r_debug.i
	$(CC) r_debug_wrap.c -shared -fPIC -I /usr/include/libr -I /usr/include/python2.6/ -o _r_debug.so -lr_debug -lr_bp -lr_reg -lr_util

mytest:
	mkdir -p r2
	cp r_bin.py* r2
	cp _r_bin* r2
	PYTHONPATH=. python test-r_bin.py

bis:
	valabind-cc --swig -NRadare python r_io -I../../libr/include r_io `pkg-config --libs r_io`

mrproper:
	a=python`python --version 2>&1 | cut -d ' ' -f 2 | cut -d . -f 1,2`/site-packages ; \
	rm -rf ${PREFIX}/lib/$a/r2

=== vapi/t/Makefile ===
include ../../config.mk

all: bin lang core asmsearch bwdisassemble regs hash sc socket asm search db io list rgot plugin.${SOEXT}
	@true

plugin.${SOEXT}:
	valac plugin.vala pluginwrap.c \
		--library=plugin -o plugin.${SOEXT} \
		--Xcc=-shared --Xcc=-fPIC --vapidir=.. \
		--pkg r_cmd --pkg r_lib --pkg r_core

rgot:
	valac --vapidir=.. rgot.vala --pkg r_bin --pkg r_util

reloc:
	valac --vapidir=.. reloc.vala --pkg r_bin --pkg r_util

bintest:
	valac --vapidir=.. bintest.vala --pkg r_bin --pkg r_util 

regs:
	valac --vapidir=.. --pkg r_reg regs.vala --pkg r_util

lang:
	valac --vapidir=.. lang.vala --pkg r_lang --pkg r_util

list:
	valac -o list list.vala --pkg r_util --vapidir=..

listc:
	valac -C -o list list.vala --pkg r_util --vapidir=..

genie:
	valac --vapidir=.. --pkg r_asm --pkg libr asm.gs
	valac --vapidir=.. --pkg r_search --pkg libr search.gs

io:
	valac --vapidir=${PWD}/.. --pkg r_io io.vala

db:
	valac --vapidir=${PWD}/.. --pkg r_db db.vala

sc:
	valac --vapidir=${PWD}/.. sc.vala --pkg r_syscall

core:
	valac --vapidir=.. core.vala --pkg r_asm --pkg r_anal --pkg r_core --pkg r_cons --pkg r_bp

asmsearch:
	valac --vapidir=.. asmsearch.vala --pkg r_core --pkg r_bin -o asmsearch

bwdisassemble:
	valac --vapidir=.. bwdisassemble.vala --pkg r_core --pkg r_bin -o bwdisassemble

search:
	valac --vapidir=${PWD}/.. search.vala --pkg r_search --pkg r_util

asm:
	valac --vapidir=.. --pkg r_asm asm.vala

bin:
	valac --vapidir=${PWD}/.. bin.vala --pkg r_bin --pkg r_util

hash:
	valac --vapidir=${PWD}/.. hash.vala --pkg r_hash

socket:
	valac --vapidir=${PWD}/.. socket.vala --pkg r_socket --pkg posix

clean:
	-rm -f `ls *.c | grep -v wrap` hash sc *.o *.h core socket asm search bin io rgot reloc asmsearch bwdisassemble

# XXX: deprecate??
#array:
#	valac --vapidir=.. --pkg r_util array.vala
#arrayc:
#	valac -C --vapidir=.. --pkg r_util array.vala

=== debian/changelog ===
radare2-bindings (0.9.6-4) unstable; urgency=low

  * debian/watch: Updated as it seems that pancake is releasing .tar.xz now.
  * debian/control: This new API breaks bokken << 1.7.

 -- David Martínez Moreno <ender@debian.org>  Fri, 17 Jan 2014 09:13:31 -0800

radare2-bindings (0.9.6-3) unstable; urgency=medium

  * debian/control: Switched Sebastian and myself as Maintainer/Uploader.
  * debian/patches/04_add_openjdk_includedir: Change the javahelper script
    output to just the output of dpkg-architecture -qDEB_HOST_ARCH.  Otherwise
    it FTBFS in armel, armhf, powerpc and powerpcsp.  Thanks to Roland Stigge
    for the bug report (closes: #733982).

 -- David Martínez Moreno <ender@debian.org>  Sat, 04 Jan 2014 01:39:49 -0800

radare2-bindings (0.9.6-2) unstable; urgency=medium

  * I'm stupid, I have been injecting paths with '-amd64' instead of
    $(JAVA_ARCH), causing everyone to fail building the sources.  Gah!
  * debian/patches/04_add_openjdk_includedir: Use JAVA_ARCH generation from
    javahelper to construct the include path.  Thanks for the hint, Aaron Ucko
    (closes: #733908).

 -- David Martínez Moreno <ender@debian.org>  Thu, 02 Jan 2014 01:57:27 -0800

radare2-bindings (0.9.6-1) unstable; urgency=low

  * New Year's release.  Just in time!
  * New upstream release.  The biggest change is that cType-based Python
    bindings are now available additionally to the usual SWIG-based ones.  For
    now they're very unstable and we'll stick to SWIG.
  * This release has been built in a pbuilder environment, which is totally
    reproducible (closes: #700406).
  * debian/control:
    - Bump version of valabind in Build-Depends to 0.7.4-3, added quilt and
      brought some of them to the present time (closes: #709718).
    - Added python and dh-python to Build-Depends to satisfy lintian.
    - Added myself in Uploaders.
    - Bump Standards-Version to 3.9.5.
    - Copy enhanced Description field from radare2.
    - Convert VCS URLs to canonical ones.
    - Added radare2-java package.
    - Added XB-Python-Version to python-radare2 (closes: #700453).
  * debian/patches:
    - Reordered and numbered.
    - add-vapi-path-to-gear-makefile: Removed.
    - 01_use_python_2.7: Refreshed and added CFLAGS support.
    - 02_bin_load_fix: The definition of bin_load() changed in libradare-0.9.6
      but it didn't in the Vala interface.  Backported from cccb90053805...
    - 03_no_forced_rpath_and_propagate_ldflags: Ported almost the same patch
      from radare2 as the problem with acr is here as well: no propagation of
      LDFLAGS and hardcoded -R (runpath) in the linking phase.
    - 04_add_openjdk_includedir: Force include of the openjdk7 in the Java
      bindings.
    - 05_fix_make_clean: Fix some leftovers in make clean.
    - 06_do_not_link_against_libpython: Moved the logic for removing libpython
      to valabind and just added --nolibpython (closes: #700450).
    - 07_add_install-ctypes_target: Added to allow installation of ctype-based
      Python bindings.
  * debian/rules:
    - Added an override for dh_clean, as config.mk is not distributed but it's
      included in the Makefile.
    - Fixed a non-existent --enable-devel flag in configure.
  * debian/copyright: Updated URL, copyrights and dates.
  * debian/compat: Bumped it to 9.  This actually made the -Wl,-z,relro flag
    to appear in the build.

 -- David Martínez Moreno <ender@debian.org>  Tue, 31 Dec 2013 23:59:12 -0800

=== debian/control ===
Source: radare2-bindings
Section: devel
Priority: extra
Maintainer: David Martínez Moreno <ender@debian.org>
Uploaders: Sebastian Reichel <sre@debian.org>
X-Python-Version: >= 2.7
Build-Depends: debhelper (>= 9),
               quilt,
               dh-python,
               libradare2-dev (>= 0.9.6),
               python,
               python2.7,
               python2.7-dev,
               gobject-introspection,
               swig,
               valabind (>= 0.7.4-3),
               valac (>= 0.20),
               javahelper,
               openjdk-7-jdk
Standards-Version: 3.9.5
Homepage: http://www.radare.org
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/radare2-bindings.git
Vcs-Git: git://anonscm.debian.org/collab-maint/radare2-bindings.git

Package: python-radare2
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Breaks: bokken (<< 1.7)
XB-Python-Version: ${python:Versions}
Description: Python bindings for radare2
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package contains the Python 2 bindings.

Package: radare2-java
Section: java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${java:Depends}
Description: Java (JNI) bindings for radare2
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package contains the Java (JNI) bindings.

Package: radare2-vala
Architecture: all
Depends: ${misc:Depends}, libradare2-dev (>= 0.9.6)
Description: Vala bindings for radare2
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package contains the Vala bindings.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with python2,javahelper

override_dh_auto_configure:
	./configure --prefix=/usr

override_dh_auto_clean:
	touch config.mk
	dh_clean
	rm -f config.mk

override_dh_auto_test:
	# do not test

override_dh_auto_build:
	cd python && make
	cd java && make

override_dh_auto_install:
	mkdir -p $(CURDIR)/debian/tmp
	make install-python install-java install-vapi DESTDIR=$(CURDIR)/debian/tmp

override_dh_python2:
	dh_python2 -ppython-radare2 --no-guessing-versions --no-guessing-deps --namespace=r2

=== debian/watch ===
version=3
http://radare.org/get/r2-bindings-([\d\.]+)\.tar\.xz
